import processing.core.*; 
import processing.data.*; 
import processing.event.*; 
import processing.opengl.*; 

import controlP5.*; 
import ddf.minim.*; 

import java.util.HashMap; 
import java.util.ArrayList; 
import java.io.File; 
import java.io.BufferedReader; 
import java.io.PrintWriter; 
import java.io.InputStream; 
import java.io.OutputStream; 
import java.io.IOException; 

public class rise extends PApplet {




Minim minim;
AudioInput sound;

ControlP5 cp5;

float hvalue;

ArrayList <PVector> frame = new ArrayList<PVector>();
ArrayList <PVector> panels = new ArrayList<PVector>();
ArrayList <PVector> lights = new ArrayList<PVector>();

FloatList lts = new FloatList();

///camera nav
int oldx = mouseX;
int oldy = mouseY;
float rotx = 0;
float roty = 0;
float rotz = -PI/2.0f;
float zcam = 100;

////controls
float amplitude;
float threshold_pulse;
float threshold_random;
boolean pulse = true;
float fade = 1.0f;
boolean wave_on = true;
float wave_amplitude = 1.0f;
float wave_speed = 1.0f;
boolean random_on = true;
float random_num;
boolean panels_on;
float panel_alpha = 100;
boolean structure_on;

float wave_count = -11;


////pulse
float pulsex = 0;
float pulsey = 0;
float pulsez = 0;
float pulse_speed = 3;
float pulse_width = 10;
float decay = 0.9f;
float dist = 99999;

///geom offset
int xo = -11;
int yo = -5; 
int zo = 0;
float scg = 1;

public void setup() {
  
  perspective(PI/3.0f,(float)width/height,1,100000);
  
  minim = new Minim(this);
  sound = minim.getLineIn(Minim.STEREO, 1024);
  
  cp5 = new ControlP5(this);
  
  cp5.addSlider("amplitude")
    .setPosition(40,40)
    .setRange(0,200)
    .setSize(200,20)
    .setValue(200)
    .setColorForeground(color(20,200,200))
    .setColorLabel(color(255))
    .setColorBackground(color(70,70,70))
    .setColorValue(color(0,0,0))
    .setColorActive(color(0,255,255))
  ;
  cp5.addSlider("threshold_pulse")
    .setPosition(40,80)
    .setRange(0,200)
    .setSize(200,20)
    .setValue(100)
    .setColorForeground(color(20,200,200))
    .setColorLabel(color(255))
    .setColorBackground(color(70,70,70))
    .setColorValue(color(0,0,0))
    .setColorActive(color(0,255,255))
  ;
  
  cp5.addSlider("threshold_random")
    .setPosition(40,120)
    .setRange(0,200)
    .setSize(200,20)
    .setValue(100)
    .setColorForeground(color(20,200,200))
    .setColorLabel(color(255))
    .setColorBackground(color(70,70,70))
    .setColorValue(color(0,0,0))
    .setColorActive(color(0,255,255))
  ;
  
    cp5.addToggle("pulse")
     .setPosition(320,40)
     .setSize(20,20)
     .setValue(true)
     .setColorForeground(color(20,200,200))
     .setColorLabel(color(255))
     .setColorBackground(color(70,70,70))
     .setColorValue(color(0,0,0))
     .setColorActive(color(0,255,255))
     ;
   
   cp5.addSlider("pulse_speed")
    .setPosition(360,40)
    .setRange(0,1)
    .setSize(200,20)
    .setValue(0.8f)
    .setColorForeground(color(20,200,200))
     .setColorLabel(color(255))
     .setColorBackground(color(70,70,70))
     .setColorValue(color(0,0,0))
     .setColorActive(color(0,255,255))
  ;
  
  cp5.addSlider("pulse_width")
    .setPosition(360,80)
    .setRange(0,5)
    .setSize(200,20)
    .setValue(2)
    .setColorForeground(color(20,200,200))
     .setColorLabel(color(255))
     .setColorBackground(color(70,70,70))
     .setColorValue(color(0,0,0))
     .setColorActive(color(0,255,255))
  ;
  
  cp5.addSlider("decay")
    .setPosition(width-280,80)
    .setRange(0.5f,1)
    .setSize(200,20)
    .setValue(0.9f)
    .setColorForeground(color(20,200,200))
     .setColorLabel(color(255))
     .setColorBackground(color(70,70,70))
     .setColorValue(color(0,0,0))
     .setColorActive(color(0,255,255))
  ;
  
   cp5.addToggle("random_on")
     .setPosition(640,40)
     .setSize(20,20)
     .setValue(true)
     .setColorForeground(color(20,200,200))
     .setColorLabel(color(255))
     .setColorBackground(color(70,70,70))
     .setColorValue(color(0,0,0))
     .setColorActive(color(0,255,255))
     ;
   
   cp5.addSlider("random_num")
    .setPosition(680,40)
    .setRange(0.9f,1)
    .setSize(200,20)
    .setValue(0.95f)
    .setColorForeground(color(20,200,200))
     .setColorLabel(color(255))
     .setColorBackground(color(70,70,70))
     .setColorValue(color(0,0,0))
     .setColorActive(color(0,255,255))
  ;
  
  cp5.addToggle("wave_on")
     .setPosition(960,40)
     .setSize(20,20)
     .setValue(true)
     .setColorForeground(color(20,200,200))
     .setColorLabel(color(255))
     .setColorBackground(color(70,70,70))
     .setColorValue(color(0,0,0))
     .setColorActive(color(0,255,255))
     ;
  
   cp5.addSlider("wave_amplitude")
    .setPosition(1000,40)
    .setRange(0,5)
    .setSize(200,20)
    .setValue(1.0f)
    .setColorForeground(color(20,200,200))
     .setColorLabel(color(255))
     .setColorBackground(color(70,70,70))
     .setColorValue(color(0,0,0))
     .setColorActive(color(0,255,255))
  ;
  
  cp5.addSlider("wave_speed")
    .setPosition(1000,80)
    .setRange(0,0.5f)
    .setSize(200,20)
    .setValue(0.4f)
    .setColorForeground(color(20,200,200))
     .setColorLabel(color(255))
     .setColorBackground(color(70,70,70))
     .setColorValue(color(0,0,0))
     .setColorActive(color(0,255,255))
  ;
  
  cp5.addToggle("panels_on")
     .setPosition(width-320,40)
     .setSize(20,20)
     .setValue(true)
     .setColorForeground(color(20,200,200))
     .setColorLabel(color(255))
     .setColorBackground(color(70,70,70))
     .setColorValue(color(0,0,0))
     .setColorActive(color(0,255,255))
     ;
     
  cp5.addToggle("structure_on")
     .setPosition(width-320,80)
     .setSize(20,20)
     .setValue(true)
     .setColorForeground(color(20,200,200))
     .setColorLabel(color(255))
     .setColorBackground(color(70,70,70))
     .setColorValue(color(0,0,0))
     .setColorActive(color(0,255,255))
     ;
     
  cp5.addSlider("panel_alpha")
    .setPosition(width-280,40)
    .setRange(0,255)
    .setSize(200,20)
    .setValue(100)
    .setColorForeground(color(20,200,200))
     .setColorLabel(color(255))
     .setColorBackground(color(70,70,70))
     .setColorValue(color(0,0,0))
     .setColorActive(color(0,255,255))
  ;
     
  cp5.addButton("ResetView")
     .setValue(0)
     .setPosition(160,160)
     .setSize(80,20)
     .setColorForeground(color(20,200,200))
     .setColorLabel(color(255))
     .setColorBackground(color(70,70,70))
     .setColorValue(color(0,0,0))
     .setColorActive(color(0,255,255))
     ;
  
  String[] vec = loadStrings("frame.txt");
  for(int i = 0; i < (vec.length/3); ++i){
    float xx = (PApplet.parseFloat(vec[i*3])+xo)*scg;
    float yy = -(PApplet.parseFloat(vec[i*3+1])+yo)*scg;
    float zz = (PApplet.parseFloat(vec[i*3+2])+zo)*scg;
    frame.add(new PVector(xx,yy,zz));
  }
  
  vec = loadStrings("panels.txt");
  for(int i = 0; i < (vec.length/3); ++i){
    float xx = (PApplet.parseFloat(vec[i*3])+xo)*scg;
    float yy = -(PApplet.parseFloat(vec[i*3+1])+yo)*scg;
    float zz = (PApplet.parseFloat(vec[i*3+2])+zo)*scg;
    panels.add(new PVector(xx,yy,zz));
  }
  
  vec = loadStrings("lights.txt");
  for(int i = 0; i < (vec.length/3); ++i){
    float xx = (PApplet.parseFloat(vec[i*3])+xo)*scg;
    float yy = -(PApplet.parseFloat(vec[i*3+1])+yo)*scg;
    float zz = (PApplet.parseFloat(vec[i*3+2])+zo)*scg;
    lights.add(new PVector(xx,yy,zz));
      lts.append(0.0f);
  }
  //noLoop();
}

public void draw() {
  background(0);
  lights();
 
  
  hvalue = 0;
  for(int i = 0; i < sound.mix.size() - 1; i++){
    //line(i, 700 + sound.mix.get(i)*amplitude, i+1, 700 + sound.mix.get(i+1)*amplitude);
    if(hvalue <  abs(sound.mix.get(i))){
      hvalue = abs(sound.mix.get(i));
    }
  }
  
  hvalue = hvalue * amplitude;
  
  if(hvalue > threshold_pulse){
     dist = 0;
     pulsez = random(-4,4);
     pulsey = random(-4,4);
     pulsex = random(-50,50);

  }

  ////sound bar////
  noStroke();
  rectMode(CORNER);
  fill(70);
  rect(40,160,50,200);
  fill(20,200,200);
  rect(40,360,50,(hvalue*-1));
  
  stroke(255);
  strokeWeight(1);
  line(100,(360-threshold_pulse),110,(360-threshold_pulse));
  line(115,(360-threshold_random),125,(360-threshold_random));
  
  
  if((pulse == true) && (hvalue > threshold_pulse)){
    pulsex = random(-10,10);
    pulsey = random(-5,5);
    pulsez = random(-1,1);
    dist = 0;
    
  }
  
  wave_count = wave_count + wave_speed;
  if(wave_count > 11){
    wave_count = -11;
  }
  
  pushMatrix();
  cam();
  
  strokeWeight(1);
  if(structure_on == true){
     for(int i = 0; i < frame.size()-1; ++i){
        PVector sp = frame.get(i);
        PVector ep = frame.get(i+1);
        stroke(255);
        strokeWeight(1);
        line(sp.x,sp.y,sp.z,ep.x,ep.y,ep.z);
        i++;
     }
  }
   
   if(panels_on == true){
     for(int i = 0; i < panels.size(); i++){
        fill(255,panel_alpha);
        noStroke();
        PVector sp = panels.get(i);
        if(sp.z == 9999){
          beginShape();
          float limit = sp.x-xo;
          for(int j=0; j < limit; j++){
            i++;
            PVector np = panels.get(i);
            vertex(np.x,np.y,np.z);
          }
          endShape();
        }
     }
   }
   
   for(int i = 0; i < lights.size();){
      float aa = lts.get(i);
      PVector np = lights.get(i);
      if(aa > 1){
        aa = aa *decay;
      }else{
        aa = 0;
      }
      lts.set(i,aa);
      float dd = dist(pulsex,pulsey,pulsez,np.x,np.y,np.z);
      if(abs(dist-dd) < pulse_width && pulse == true){
        lts.set(i,255);
      }
       dd = dist(wave_count,0,0,np.x,0,0);
      if(dd < wave_amplitude && wave_on == true){
        lts.set(i,255);
      }
      float rr = random(0,8.0f);
      if(hvalue > threshold_random && random_on == true && rr < random_num){
        lts.set(i,255);
      }
      fill(255,aa); 
      noStroke();
      beginShape();
      for(int j=0; j < 4; j++){
        np = lights.get(i);
        vertex(np.x,np.y,np.z);
        i++;
      }
      endShape();
   }
  
   popMatrix();
   
   dist = dist + pulse_speed;
   
}

public void cam() {
  int newx = mouseX;
  int newy = mouseY;
  translate(width/2, height/2,zcam);
  rotateY(rotx);
  rotateX(roty);
  rotateZ(rotz+PI/2);
  translate(0,0,0);
  //rotateZ(PI);
  if ((mousePressed == true) && (mouseY > 200)) {
    rotx = rotx + (oldx-newx)/50.0f;
    roty = roty + (oldy-newy)/50.0f;
  }
  oldx = newx;
  oldy = newy;
  
  
  //println("X  " + rotx);
  //println("Y  " + roty);
  //println("Z  " + zcam);
}

public void mouseWheel(MouseEvent event) {
  float e = event.getCount();
  zcam = zcam - e*5;
}


public void ResetView() {
  rotx = 0;
  roty = 0;
  rotz = -PI/2.0f;
  zcam = 760;
}
  public void settings() {  size(1800,900,P3D); }
  static public void main(String[] passedArgs) {
    String[] appletArgs = new String[] { "--present", "--window-color=#666666", "--stop-color=#cccccc", "rise" };
    if (passedArgs != null) {
      PApplet.main(concat(appletArgs, passedArgs));
    } else {
      PApplet.main(appletArgs);
    }
  }
}
